package org.example;

import org.example.filter.AuthenticationFilter;
import org.example.todo.TodoCSVMessageConverter;
import org.springframework.boot.web.servlet.FilterRegistrationBean;
import org.springframework.context.annotation.Bean;
import org.springframework.context.annotation.Configuration;
import org.springframework.http.converter.HttpMessageConverter;
import org.springframework.web.servlet.config.annotation.WebMvcConfigurer;

import java.util.List;

@Configuration
public class WebConfig implements WebMvcConfigurer {

	@Override
	public void configureMessageConverters(List<HttpMessageConverter<?>> converters) {
		converters.add(new TodoCSVMessageConverter());
	}

	@Bean
	public FilterRegistrationBean<AuthenticationFilter> authFilterRegistration(AuthenticationFilter authFilter) {
		FilterRegistrationBean<AuthenticationFilter> registration = new FilterRegistrationBean<>();
		registration.setFilter(authFilter);
		registration.addUrlPatterns("/todos/*");
		registration.setOrder(2);
		return registration;
	}
}
